#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
typedef vector<int> vi;
typedef vector<ll> vll;
 
typedef vector<vi> vvi;
typedef vector<vll> vvll;
 
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
 
typedef vector<pii> vpii;
typedef vector<pll> vpll;
 
typedef vector<vpii> vvpii;
typedef vector<vpll> vvpll;
 
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second
 
template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}
 
namespace debug {
    void __print(int x) {cerr << x;}
    void __print(long long x) {cerr << x;}
    void __print(double x) {cerr << x;}
    void __print(long double x) {cerr << x;}
    void __print(char x) {cerr << '\'' << x << '\'';}
    void __print(const string &x) {cerr << '\"' << x << '\"';}
    void __print(const char *x) {cerr << '\"' << x << '\"';}
    void __print(bool x) {cerr << (x ? "true" : "false");}
 
    template<typename T, typename V>
    void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
    template<typename T>
    void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
    void _print() {cerr << "]\n";}
    template <typename T, typename... V>
    void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}
 
#ifdef ljuba
#define dbg(x...) cerr << "\e[91m" << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x)
#else
#define dbg(x...)
#endif
}
 
using namespace debug;
 
const char nl = '\n';
 
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
/*
???????? ?????? ???????, ??? ???? ??? ????????????? (????? ???? ???????? ?????) 
?????? ?? ????????? ???? ????? ????????? ?? ??????, ????????? ??????? ? ???????
*/

void solve() {
    //xayya
    string s;
    cin >> s;

    int n = sz(s);
    
    bool palindrom = true;
    for(int i = 0; i < n; ++i) {
        if(s[i] != s[n-1-i]) {
            palindrom = false;
            string temp;
            for(int j = i; j <= n-1-i; ++j) {
                temp += s[j];
            }
            s = temp;
            break;
        }
    }

    if(palindrom) {
        cout << 1 << nl;
        return;
    }

    n = sz(s);

    //auto check = [](string gas) {
        //string temp = gas;
        //reverse(all(temp));
        //return temp == gas;
    //};

    auto resi = [&]() {
        int ans = n-1;
        int l = 0, r = n-1;
        while(l <= r) {
            dbg(l, r);
            int mid = (l + r) / 2;
            vi cnt(26);
            for(int i = 0; i <= mid; ++i) {
                ++cnt[s[i]-'a'];
            }

            int idiDo = -1;
            for(int i = n-1; i > mid; --i) {
                if(cnt[s[i]-'a'] == 0) {
                    idiDo = i+1;
                    break;
                }
                --cnt[s[i]-'a'];
            }

            if(idiDo == n) {
                l = mid + 1;
                continue;
            }

            if(idiDo == -1) {
                ans = mid;
                r = mid - 1;
                continue;
            }

            bool ok = true;

            for(int i = idiDo-1; i > mid; --i) {
                int c = s[i] - 'a';
                if(cnt[c] == 0) {
                    ok = false;
                    break;
                }
                --cnt[c];
            }

            if(!ok) {
                l = mid + 1;
                continue;
            }

            if(ok) {
                int ima = 0;
                for(int i = 0; i < 26; ++i) {
                    ima += (cnt[i] % 2);
                }
                ok &= (ima <= 1);
            }

            if(ok) {
                ans = mid;
                r = mid - 1;
            } else {
                l = mid + 1;
            }
        }

        ++ans;
        return ans;
    };

    int ans = n;
    ckmin(ans, resi());
    reverse(all(s));
    ckmin(ans, resi());
    cout << ans << nl;
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    int testCases = 1;
    //cin >> testCases;
    while(testCases--)
        solve();
}